/************************************************************************************************/
/**
* @file               common.c
* @author             MCU Ecosystem Development Team
* @brief              通用函数或本外设相关的配置实现函数。
*
*
**************************************************************************************************
* @attention
* Copyright (c) CEC Huada Electronic Design Co.,Ltd. All rights reserved.
*
**************************************************************************************************
*/

/*------------------------------------------includes--------------------------------------------*/
#include "common.h"

/*-------------------------------------------functions------------------------------------------*/
/**
* @brief  系统时钟配置
* @retval 无
*/
void system_clock_config(void)
{
    uint32_t ahbdiv_tmp;
    
    /* 设置Flash读访问等待时间 */
    std_flash_set_latency(FLASH_LATENCY_1CLK);

    /* 使能RCH */
    std_rcc_rch_enable();
    while(!std_rcc_get_rch_ready());
    
    /* 备份AHB分频参数 */
    ahbdiv_tmp = std_rcc_get_ahbdiv();    
    /* 配置AHB最大分频：128分频 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV128);  
    
    /* 切换RCH4到RCH48 */    
    std_rcc_set_rch_source(RCC_RCH_FREQ_48M);
    
    /* 恢复AHB分频参数 */
    std_rcc_set_ahbdiv(ahbdiv_tmp);      

    /* 设置系统时钟源为RCH */
    std_rcc_set_sysclk_source(RCC_SYSCLK_SRC_RCH);
    while(std_rcc_get_sysclk_source() != RCC_SYSCLK_SRC_STATUS_RCH);

    /* 设置AHB分频因子 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV1);
    /* 设置APB分频因子 */
    std_rcc_set_apbdiv(RCC_PCLK_DIV1);
    
    SystemCoreClockUpdate(); 
}



/**
* @brief  GPIO 初始化
* @retval 无
*/
void gpio_init(void)
{
    std_gpio_init_t spi_gpio_init = {0};
    std_gpio_init_t nss_gpio_init = {0};
    
    /* GPIO外设时钟使能 */  
    std_rcc_gpio_clk_enable(RCC_PERIPH_CLK_GPIOA);

    /* SPI1 GPIO 配置    
       PA5  ------> SPI1_SCK
       PA6  ------> SPI1_MISO
       PA7  ------> SPI1_MOSI
    */
    spi_gpio_init.pin = GPIO_PIN_6 | GPIO_PIN_7;
    spi_gpio_init.mode = GPIO_MODE_ALTERNATE;
    spi_gpio_init.pull = GPIO_NOPULL;
    spi_gpio_init.output_type = GPIO_OUTPUT_PUSHPULL;
    spi_gpio_init.alternate = GPIO_AF0_SPI1;
    std_gpio_init(GPIOA, &spi_gpio_init);
    
    spi_gpio_init.pin = GPIO_PIN_5;
    spi_gpio_init.mode = GPIO_MODE_ALTERNATE;
    spi_gpio_init.pull = GPIO_PULLUP;
    spi_gpio_init.output_type = GPIO_OUTPUT_PUSHPULL;
    spi_gpio_init.alternate = GPIO_AF0_SPI1;
    std_gpio_init(GPIOA, &spi_gpio_init);


    /* NSS GPIO 配置    
       PA3 ------> SPI1_NSS
    */
    nss_gpio_init.pin = GPIO_PIN_3;
    nss_gpio_init.mode = GPIO_MODE_OUTPUT;
    spi_gpio_init.pull = GPIO_PULLUP;
    spi_gpio_init.output_type = GPIO_OUTPUT_PUSHPULL;
    std_gpio_init(GPIOA, &nss_gpio_init);
    
    /* NSS默认高电平 */
    std_gpio_set_pin(GPIOA, GPIO_PIN_3);
}


/**
* @brief  SPI1初始化
* @retval 无
*/
void spi1_init(void)
{
    std_spi_init_t spi_init = {0};
    
    /* SPI1时钟使能 */
    std_rcc_apb2_clk_enable(RCC_PERIPH_CLK_SPI1);
    
    /* 禁止SPI */
    std_spi_disable(SPI1);
    
    /* SPI结构体初始化 */
    spi_init.mode = SPI_MODE_MASTER;
    spi_init.baud_rate_prescaler = SPI_BAUDRATEPRESCALER_32;
    spi_init.clk_polarity = SPI_POLARITY_HIGH;
    spi_init.clk_phase = SPI_PHASE_1EDGE;
    spi_init.bitorder = SPI_FIRSTBIT_MSB;
    std_spi_init(SPI1, &spi_init);
    
    /* SPI主机模式，配置NSS输出使能 */
    std_spi_nss_output_enable(SPI1);
    
    /* SPI使能 */
    std_spi_enable(SPI1);
}



